;* DO NOT CHANGE THIS FILE IF YOU DON'T KNOW AUTOLISP 
;*    ,       AUTOLISP. 
;* 
;;***************** ACAD.LSP rel.16.09.2004 ******************** 
;*  Acad.lsp    ,  Acad  
;*      DWG ,      ().
;*         :
;*   -   ;
;*   -        ;
;*   -  ()       ;
;*   -   ( )   Acad   ;
;*   -    Acad    ;
;*   -    ( 9)      Acad;
;*   -     .
;*         ($_SETUP1)   SETUP1.LSP
;* 
;* :    Acad  ,    ,  
;*      .,       Acad.
;* 
;*        (     ).
;*     ,     html help.
;* 
;* :
;*  DOSLib 6.1. 1992-2004 Robert McNeel & Associates. All rights reserved. (www.mcneel.com)
;*    Acad Express
;* 
;*  Acad 15, 16
;* (C)KAI, Kosov Alexander, 2004, Magadan, Russia
;*  : http://geol-dh.narod.ru/                  ()
;* Site : http://geol-dh.narod.ru/en_index.html     (English)
;*
;*     :
;*   acad.lsp -    (,  ,  )
;*   setup1.lsp -   
;*   setup1.dcl -   
;*   setup1_mes.lsp -    (2 )
;*   doslib15.arx ( doslib16.arx) -   Acad 15 ( 16)
;*   *.dwg -  
;*   :
;*   setup1.sld -  
;*   setup1_read_me.html -   (  )
;*   *.gif -    
;*   geo.css -     
;* 
;* :
;*   -  ,      ;
;*   -    9      MNU;
;*   -   (  )   - ;
;* 
(defun-q SETUP1-STARTUP ( / appname_folder  loglst  sld_name  check_num_lst  check_name_lst  dwg_dir
                            curdate  time  acadver  arxname  flag1  flag2  flag3
                            ;  
                            mes_language-  log_filename-)
         
; *************                     ******************
         
  ; ,       (  )
  ;    ,      .  -   ().
  ;    (   MNU),    (   ,
  ;      9,   ).
  ;   DWT (   )      .
  ;
  ;         Acad.
  ;
  ;   :
  ;
  ;   (     Acad),    
  ;             
  (setq appname_folder "FA programs")
  ;   (SLD ),        
  (setq sld_name "SETUP1")
         
  ;          ,    :
         
  ;        /     ( )
  ;  ,     
  (setq check_num_lst (list '("*.*" 66) ;        66  
                            '("*.FAS" 14);  FAS     14  
;;;                            '("*.LSP" 100);   
                      ))
;;;  (setq check_num_lst nil) ;  NIL   (     )
         
  ;        (    )
  ; ,     
  (setq check_name_lst '("SEEL.FAS"
                         "SEEL.DCL"
                         "SEEL.SET"
                         "KAI-2001-FW.hlp"
                         "KAI-2001-FW.cnt"
;;;                         "OPER.BMP";   
                        ))
;;;  (setq check_name_lst nil) ;  NIL   (  )
         
  ;   -,      ,    
  ;         (    CD).
  (setq log_filename- "Setup1_LOG.txt")
  ;   html,      Help.
  (setq help_filename- "SETUP1_READ_ME.html")
         
; *************                 ******************

  (setq loglst '()) ;     LOG .
  ;   ,    SETUP1   DWG 
  (setq dwg_dir (getvar "DWGPREFIX"))
  (setq curdate (rtos (fix (getvar "CDATE")) 2 0)
        curdate (strcat (substr curdate 7 2) "." (substr curdate 5 2) "." (substr curdate 1 4));  
        time (rtos (- (getvar "CDATE") (fix (getvar "CDATE"))) 2 4)
        time (strcat (substr time 3 2) ":" (substr time 5 2));  
  );setq
  ;   LOG 
  (setq loglst (cons (strcat appname_folder " " "SETUP1 log file." "  [" curdate "  " time "]") loglst))
  (setq loglst (cons "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -" loglst))
  (if (= (getvar "SYSCODEPAGE") "ANSI_1251");   
    (progn
      (setq mes_language- 2)
      (princ (strcat "\n\n" "Set RUSSIAN language of setup interface."))
      (setq loglst (cons (strcat  "Set RUSSIAN language of setup interface.") loglst))
    )
    (progn; NOT RUSSIAN code page
      (setq mes_language- 1)
      (princ (strcat "\n" "Set ENGLISH language of setup interface."))
      (setq loglst (cons (strcat "Set ENGLISH language of setup interface.") loglst))
    )
  )
  ; [1-ENG, 2-RUS]    (set language forcedly)
;;;  (setq mes_language- 1)
  (setq acadver (substr (getvar "ACADVER") 1 2))
  ;    (DOSLib 6.1, www.mcneel.com)     Acad
  (if (= acadver "15")
    (setq arxname "doslib15.arx")
    (setq arxname "doslib16.arx")
  )
  ; ,    ,    
  (if (and (or (findfile (strcat dwg_dir "SETUP1.fas"))
               (findfile (strcat dwg_dir "SETUP1.lsp")));
           (findfile (strcat dwg_dir "SETUP1.dcl"))
           (or (findfile (strcat dwg_dir "SETUP1_MES.fas"))
               (findfile (strcat dwg_dir "SETUP1_MES.lsp")))
           (findfile (strcat dwg_dir arxname))
           )
    (progn
      ;     
      (setq loglst (cons (strcat "Initializing messages...") loglst))
      (princ (strcat "\n" "Initializing messages..."))
      (setq flag1 (load "SETUP1_MES" nil));      2- 
      (if flag1
        (princ (strcat "OK\n"))
        (progn
          (princ (strcat "Not loaded!\n"))
          (setq loglst (cons (strcat "Messages file not loaded!") loglst))
        )
      )
      (princ (strcat "\n" "Loading setup file..."))
      (setq loglst (cons (strcat "Loading setup file...") loglst))
      (setq flag2 (load "SETUP1" nil));   
      (if flag2
        (princ (strcat "OK\n"))
        (progn
          (princ (strcat "Setup file not loaded!" "\n"))
          (setq loglst (cons (strcat "Setup file not loaded!") loglst))
        )
      )
      (setq loglst (cons (strcat (MESS 0)) loglst)) ; 0="Loading DOSLib arx file..."
      (princ (strcat "\n" (MESS 0))) ; 0="Loading DOSLib arx file..."
      (setq flag3 (arxload arxname nil));   DOSLib!
      (if flag3
        (princ (strcat "OK\n"))
        (progn
          (princ (strcat "Not loaded!\n"))
          (setq loglst (cons (strcat (MESS 1)) loglst)) ;1="DOSLib arx file not loaded!"
        )
      )
      (if (and flag1 flag2 flag3)
        ;    ,     :
        ($_SETUP1 arxname        ;       
                  appname_folder ;       
                  check_num_lst  ;       
                  check_name_lst ;         
                  loglst         ;     LOG 
                  sld_name)      ;      ( )
        (progn
          ; -    
          (alert (strcat (MESS 2) ;2="Some of needed setup programs not loaded."
                         "\n\n" (MESS 3) ;3="Can NOT setup applications."
                 ))
        )
      )
    )
    (progn
      ; -      (    ,        Acad)
      (alert (strcat (MESS 4) ;4="Setup program files not found.  SETUP1.FAS(LSP) or SETUP1.DCL or SETUP1_MES.FAS(LSP) or"
                     " " arxname ;
                     "\n\n" (MESS 3) ;3="Can NOT setup applications."
             ))
    )
  )
  (prin1)
);end of *** SETUP1-STARTUP ****

;  SETUP1-STARTUP     
(setq S::STARTUP (append S::STARTUP SETUP1-STARTUP))
(prin1)

