;* OPEN SOURCE.     KAI-2001 (http://geol-dh.narod.ru/)
;* 
;**************** C:B1 ****** Break_1-st_point **************
;* 
;*  BREAK (    , )
;*        Esc   .
;* 
;* Acad 15,16 ( 13-14  )
;* ()  .., 1994,1998,2001,2003
;* .. . (413-22)5-05-10.
;* : http://geol-dh.narod.ru/   Email: ai_kosov@mail.ru
;* 
;*      ( ,      .)
;*          .
;*         .    .
;*          (, ).
;* 
;*        (),
;*    ( , , ).
;
;
;   :
; MES_B1
; M_ERROR_B1
; RESTORE_ON_EXIT_B1
;
;* --------------- 
;*  Acad B1 
;* --------------- 
;
(defun C:B1 ( / lang mlst old-error cmde loop en_pt break_pt en eprev )

  ;*    (Language support)
  (setq lang 2);[1  2] 2-  -  (  )
               ;          1- English language
  
  ;.   ,     : ACAD.LSP, *.MNL, ...
  ;(Set variable for English support in ACAD.LSP, *.MNL, ...)
  (if (and language$- (or (= language$- 1)(= language$- 2)))
    (setq lang language$-)
  )
  ;*    2 
  ;*      2-  3-  ()!
  (setq mlst '(
    (0 "Breaking object in specified point." "    .")
    (1 "Select object to break" "  ")
    (2 "Specify point to break object" "  ")
    (3 "CAN'T BREAKE OBJECT!" "  !")
    (4 "Object on locked layer, break point on end or outside object..." "   ,        ...")
  ));end of list ** mlst ** ( )
  ;
  ; ----------------------------------------------
  ;       2 
  ; ----------------------------------------------
  (defun MES_B1 (num / mes2)
    ;num  =  (int)   mlst
    (if (and mlst (setq mes2 (nth num mlst))); = '(num "str_eng" str2_rus")
      (setq mes2 (nth lang mes2));    
    )  
    (if (not mes2);      
      (progn
        (alert (strcat (itoa num) "\n" "Message not found."))
        (setq mes2 "_?_")
      )
    )
    mes2
  );end of **** MES_B1 *****
  ;
  ; ------------------------
  ;   
  ; ------------------------
  (defun M_ERROR_B1 (errnumber)
    ;  Esc
    (if (not (member errnumber '("Function cancelled" "console break" "quit / exit abort")))
      (princ (strcat "\nERROR in program B1: " errnumber))
    )
    (RESTORE_ON_EXIT_B1);     
  );end of ** M_ERROR_B1 **
  ;
  ; -------------------------------------------
  ;     
  ; -------------------------------------------
  (defun RESTORE_ON_EXIT_B1 ()
    (if old-error (setq *error* old-error)) ; Restore old *error* handler
    (if en (redraw en 4))
    (command "._UNDO" "_END")         ;   
    (if cmde (setvar "CMDECHO" cmde)); Restore cmdecho value
    (prin1)
  ) ;end of ******* RESTORE_ON_EXIT_B1 ********
  ;
  ; *********************************
  ;    **************
  ; *********************************
  ;
  ;  
  (setq cmde (getvar "cmdecho")    ; save current setting of cmdecho
        old-error  *error*         ; save current error function
        *error* M_ERROR_B1         ; new error function
  )
  (setvar "CMDECHO" 0)
  (command "._UNDO" "_BEGIN") ;  ,   
  ;       F1
  (if (findfile "KAI-2001-FW.HLP")
    (setfunhelp (strcat "C:" "B1") "KAI-2001-FW.HLP" "B1")
    (princ (strcat "\n KAI-2001-FW.HLP"  "  " (MES_CT 19)));19="Help file not found."
  )
  (princ (strcat "\n(C)KAI (FA). C:B1. " (MES_B1 0)));0="    ."
  (setq loop T)
  (while loop
    (setq en_pt nil break_pt nil)
    (setq en_pt (entsel (strcat "\n" (MES_B1 1) ": ")));1="  "
    (if en_pt
      (progn
        (setq en (car en_pt))
        (redraw en 3)
        (setq break_pt (getpoint (strcat "  *" (MES_B1 2) ": ")));2="  "
        (redraw en 4)
        (setq eprev (entlast));     Acad
        (if break_pt
          (progn
            ;     
            (command "._BREAK" en break_pt break_pt)
            ; ,  ?
            (if (equal eprev (entlast))
              (alert (strcat " " (MES_B1 3) " ";3="  !"
                             "\n\n" (MES_B1 4);4="   ,        ..."
                             ))
              (princ " OK.")
            )
          )
        )
      )
      (setq loop nil);     -     
    )
  );while loop
  (princ "\n* End C:B1 *")
  (RESTORE_ON_EXIT_B1);  ,  
  (prin1);  
) ;end ************** C:B1 ***************