;* OPEN SOURCE.     KAI-2001 (http://geol-dh.narod.ru/)
;* 
;**************** C:BHL ****** Break_Hidden_Line **************
;*
;* BHL         
;*                (  ).
;*           .
;*    :
;*        INT
;*        CYAN,   HIDDEN (.  SET)
;*   
;*    : Gary A. Moretz, Montverde, Fla.
;* 
;* Acad 15,16 ( 13-14  )
;* ()  .., 1994,1998,2001,2003
;* .. . (413-22)5-05-10.
;* : http://geol-dh.narod.ru/   Email: ai_kosov@mail.ru
;* 
;*      ( ,      .)
;*          .
;*         .    .
;*          (, ).
;* 
;*        (),
;*    ( , , ).
;
;   :
; BHL_HELP
; BHL_MES
; BHL_CHCOLOR
; BHL_ERROR
; BHL_RESTORE_ON_EXIT
; BHL_DOUNDO
;
;* ---------------- 
;*  Acad BHL 
;* ---------------- 
;
(defun C:BHL (/ bhl_meslist-
                bhlmodecol- bhlmodelt- bhlmodeint- l-undo hh str
                cmde old-error osn_ pt1 pt2  ang1-2 ptline1 ang2-1 ptline2 h en-pt j en 
                lt_list ltname sortlist)
  ;*    (Language support)
  (setq lang 2);[1  2] 2-  -  (  )
               ;          1- English language
  
  ;.   ,     : ACAD.LSP, *.MNL, ...
  ;(Set variable for English support in ACAD.LSP, *.MNL, ...)
  (if (and kai_language- (or (= kai_language- 1)(= kai_language- 2)))
    (setq lang kai_language-)
  )
  ;
  ; -----------------------------------
  ;      
  ; -----------------------------------
  (defun BHL_HELP (index / )
    (if (findfile "KAI-2001-FW.HLP")
      (help "KAI-2001-FW.HLP" index)
      (princ (strcat "\n KAI-2001-FW.HLP"  "  " (BHL_MES 19)));19="Help file not found."
    )
  ) ;end ****** BHL_HELP **************
  ;
  ;
  ; ----------------------------------------------
  ;       2 
  ; ----------------------------------------------
  (defun BHL_MES (num / mes2)
    ;num  =  (int)   bhl_meslist- (. SET )
    (if (and bhl_meslist- (setq mes2 (nth num bhl_meslist-))); = '(num "str_eng" str2_rus")
      (setq mes2 (nth lang mes2));    
    )  
    (if (not mes2);      
      (progn
        (alert (strcat (itoa num) "\n" "Message not found."))
        (setq mes2 "_?_")
      )
    )
    mes2
  );end of **** BHL_MES *****
  
  ;
  ; ---------------------------------------------- 
  ;       
  ; ---------------------------------------------- 
  (defun BHL_CHCOLOR (digcol / chcol)
    ;digcol -   0-256 .
    (cond ((= digcol 0)  (setq chcol "BYBLOCK"))
          ((= digcol 1) (setq chcol "RED"))
          ((= digcol 2) (setq chcol "YELLOW"))
          ((= digcol 3) (setq chcol "GREEN"))
          ((= digcol 4) (setq chcol "CYAN"))
          ((= digcol 5) (setq chcol "BLUE"))
          ((= digcol 6) (setq chcol "MAGENTA"))
          ((= digcol 7) (setq chcol "WHITE"))
          ((and (> digcol 7) (< digcol 256))
          (setq chcol (itoa digcol)))
          (T (setq chcol "BYLAYER"));    -  
    )
    chcol ;:    
  ); end of ************ BHL_CHCOLOR ***********
  ;
  ; ------------------------
  ;   
  ; ------------------------
  (defun BHL_ERROR (errnumber)
    (if (not (member errnumber '("Function cancelled" "console break" "quit / exit abort")))
      (princ (strcat "\nERROR in program BHL: " errnumber))
    )
    (BHL_RESTORE_ON_EXIT)
    (prin1)
  ) ;end of ** BHL_ERROR **
  ;
  ; -------------------------------------------
  ;     
  ; -------------------------------------------
  (defun BHL_RESTORE_ON_EXIT ()
    (if old-error (setq *error* old-error)) ; Restore old *error* handler
    (if osn_  (setvar "OSMODE" osn_))  ; 
    (if ccol_ (setvar "CECOLOR" ccol_)); 
    (if clt_  (setvar "CELTYPE" clt_)) ;  
    (if en    (redraw en 4));   
    (if cmde  (setvar "CMDECHO" cmde))  ; Restore cmdecho value
  ) ;end of ******* BHL_RESTORE_ON_EXIT ********
  ;
  ; ------------------------------------------
  ;     
  ; ------------------------------------------
  (defun BHL_DOUNDO ()
    (if (> (length l-undo) 0) ;  1- 
      (progn
        (setq l-undo  (cdr l-undo)) ;    
        (command "._UNDO" "_Back")   ;     
      )
      (alert (strcat "  " (BHL_MES 0) "  "));0="Nothing to UNDO."
    )
  ) ; end of ** DOUNDO **
  ;
  ; *********************************
  ;    **************
  ; *********************************
  ;
  ;  
  (setq cmde (getvar "CMDECHO")  ; save current setting of cmdecho
        osn_ (getvar "OSMODE")   ; 
        ccol_ (getvar "CECOLOR") ; 
        clt_ (getvar "CELTYPE")  ;  
        old-error  *error*       ; save current error function
        *error* BHL_ERROR        ; new error function
  )
  (setvar "CMDECHO" 0)
  (if (findfile "BHL.SET");   setup
    (progn
      (princ (strcat "\nLoading parameters from BHL.SET..."));     .
      (load "BHL.SET")
      (princ (strcat "OK\n"))
    )
    (progn
      (alert "BHL.SET.  Parameters file not found.\n\nCancel program.")
      (EXIT)
    )
  )
  ;   
  (BHL_SETUP)
  ;       F1
  (if (findfile "KAI-2001-FW.HLP")
    (setfunhelp (strcat "C:" "BHL") "KAI-2001-FW.HLP" "BHL")
    (princ (strcat "\n KAI-2001-FW.HLP"  "  " (BHL_MES 19)));19="Help file not found."
  )
  ;   
  (princ (strcat "\n(C)KAI (FA). C:BHL. "
                 (BHL_MES 1)));1="Break objects, and create instead hidden line."
  ;     ?
  (if (not (tblsearch "LTYPE" bhllt-))
    (progn
      (princ (strcat "\n" bhllt- ".  " (BHL_MES 18)));18="Default LineType is not loaded."
      (setq bhllt- (strcase (getvar "CELTYPE")));  
    )
  )
  (setq l-undo nil);    
  (setq loop T)
  ;  
  (while loop
    ;  
    (princ (strcat "\n " (BHL_MES 2) ": ";2="Current parameters"
                       "Offset" "=" (rtos bhloff- 2 3) ". " 
                       (if (= bhlmodelt- 1);    (  SET   )
                         (strcat (BHL_MES 4) "=" (strcase bhllt-) ". ");4="LineType"
                         (strcat (BHL_MES 4) "=";4="LineType"
                                 (BHL_MES 3) ". ");3="Current"
                       )
                       (if (= bhlmodelt- 1);   (  SET   )
                         (strcat (BHL_MES 5) "=" (BHL_CHCOLOR  bhlcol-) ".");5="Color"
                         (strcat (BHL_MES 5) "=";5="Color"
                                 (BHL_MES 3) ".");3="Current"
                       )
          ))
    (setq en-pt nil)
    (setvar "OSMODE" osn_);      
    ;     
    (initget "Offset Color LType Help Undo")
    (if (setq en-pt (entsel (strcat "\n" (BHL_MES 6);6="Select object to hide or"
                                  " [Offset/LType/Color/Undo/Help] ")))
      (setq loop T)
      (setq loop nil);     -     
    )
    ;  
    (cond ((= en-pt "Offset")
             (progn
               ;      ,    
               ;   -        ,    
               (if (setq j (getdist (strcat "\n * " (BHL_MES 7);7="Specify offset"
                                            " <" (rtos bhloff- 2 3) "> :" )))
                 (setq bhloff- j)
               )
               (setq en-pt nil);    COND
             ))
          ((= en-pt "Color")
            (progn
              ;       Acad
              (if (= bhlmodecol- 1)
                (if (setq j (acad_colordlg bhlcol- 1))
                  (setq bhlcol- j)
                )
                (alert (BHL_MES 8));8="To change color set mode in SET file."
              )
              (setq en-pt nil);    COND
            ))
          ((= en-pt "LType")
            (progn
              ;   
              (setq lt_list (tblnext "LTYPE" T));    1    
              (while lt_list
                (setq ltname (strcase (cdr (assoc 2 lt_list))));   ()
                (if (/= ltname "");     
                  (setq sortlist (cons ltname sortlist));
                ) 
                (setq lt_list (tblnext "LTYPE"));      
              );while
              ;   ByLayer
              (setq sortlist (append (list "ByLayer") sortlist))
              ;   
              (if (>= (getvar "MAXSORT") (length sortlist))
                (setq sortlist (acad_strlsort sortlist))
                (alert (strcat (BHL_MES 29) ": " (itoa (length sortlist))));29="To sort styles name set sysvar value 'MAXSORT' more then"
              )
              ;         ( DCL  )
              (setq str (strcat "\n-----------------------"))
              (foreach n sortlist
                (setq str (strcat str "\n  " n)) 
              );foreach
              ;       
              (princ (strcat str " * " (BHL_MES 20)));20="See above existing linetypes."
              ;        
              (if (= bhlmodelt- 1)
                (if (setq j (strcase (getstring (strcat "\n * " (BHL_MES 9);9="Enter LineType name"
                                               " <" bhllt- ">: "))))
                  (progn
                    (if (/= j "")
                      (if (tblsearch "LTYPE" j)
                        (setq bhllt- j)
                        (alert (strcat (strcase j) ".  " (BHL_MES 10);10="This LineType not set in DWG."
                                         "\n" (BHL_MES 11)));11="Load LineType first by command LINETYPE."
                      )
                    )
                  )
                )
                (alert (BHL_MES 12));12="To change TypeLine set mode in SET file."
              )
              (setq en-pt nil);    COND
            ))
          ((= en-pt "Undo")
            (progn
              ;     (..   )
              (BHL_DOUNDO)
              (setq en-pt nil);    COND
            ))
          ((= en-pt "Help")
            (progn
              (BHL_HELP "BHL");   help   
              (setq en-pt nil);    COND
            ))
    );cond
    (setq osn_ (getvar "OSMODE"));    (      )
    ;  
    (if (and en-pt 
             (setq lay (cdr (assoc 8 (entget (car en-pt)))));   ,  
             (not (zerop (logand (cdr (assoc 70 (tblsearch "LAYER" lay))) (+ 1 2 4 16 32)))));  ?  XREF?
      (progn
        (alert (strcat (BHL_MES 13);13="Can't break object."
                       "\n" (BHL_MES 14)));14="Locked or Xref layer."
        (setq en-pt nil);    
      )
    )
    ;       
    (if en-pt
      (progn
        (setq en (car en-pt)); entity name
        (setq en-pt (cadr en-pt)); 
        (redraw en 3);   
        (setvar "OSMODE" osn_);      
        (if (= bhlmodeint- 1)
          (setvar "OSMODE" 32);     INT (    SET )
        )
        ;  pt1  pt2     !!
        ;         pt1-2  .
        (setq pt1 (getpoint (strcat "\n " (BHL_MES 15);15="Specify first point"
                           (if (= bhlmodeint- 1)
                             " [OSNAP=INT!] ";    
                             " "
                           )
                  )))
        (if (/= bhlmodeint- 1)
          (setq osn_ (getvar "OSMODE"))
        )
        (if pt1
          (progn
            (if (= bhlmodeint- 1)
              (setvar "OSMODE" 32)
             )
            (setq pt2 (getpoint pt1 (strcat "\n  " (BHL_MES 16) ;16="Specify second point"
                                          (if (= bhlmodeint- 1)
                                            " [OSNAP=INT!] ";    
                                            " "
                                          )
                     )))
            (if (/= bhlmodeint- 1)
              (setq osn_ (getvar "OSMODE"))
            )
            (if pt2
              (progn
                (setq ang1-2 (angle pt1 pt2))
                (setq ptline1 (polar pt1 ang1-2 bhloff-))
                (setq ang2-1 (angle pt2 pt1))
                (setq ptline2 (polar pt2 ang2-1 bhloff-))
                ;     
                (command "._UNDO" "_Mark")
                (setq l-undo  (append (list 1) l-undo))
                (setvar "OSMODE" 0);      
                ;   
                (command "._BREAK" en-pt "_F" pt1 pt2)
                (if (not (equal ptline1 ptline2 0.00000000));    
                  (progn
                    ;      
                    (if (and (= bhlmodelt- 1)(tblsearch "LTYPE" bhllt-))
                      (setvar "CELTYPE" bhllt-)
                    )
                    (if(= bhlmodecol- 1)
                      (setvar "CECOLOR" (BHL_CHCOLOR  bhlcol-))
                    )
                    ;  
                    (command "._LINE" ptline1 ptline2 "");   !!
                  )
                  (alert (BHL_MES 17));17="First and second point are equal."
                );if
                ;  
                (if ccol_ (setvar "CECOLOR" ccol_))
                (if clt_  (setvar "CELTYPE" clt_))
              )
            )
          )
        )
      );progn
    );if en-pt
  );while
  (BHL_RESTORE_ON_EXIT);  ,  
  (prin1);  
);end of ***** C:BHL ******
