;* OPEN SOURCE.     KAI-2001 (http://geol-dh.narod.ru/)
;* 
;**************** C:CT ****** Change_Text **************
;* 
;*      (TEXT, MTEXT).
;*  ( :   ,     ,        )
;*       (  ).
;* 
;*    (     1-  )
;* 
;* :  MTEXT     (     256 )
;*                   (     )
;* 
;* !   (   )  !
;* 
;* Acad 15,16 ( 13-14  )
;* ()  .., 1997,1998,2001,2003
;* .. . (413-22)5-05-10.
;* : http://geol-dh.narod.ru/   Email: ai_kosov@mail.ru
;* 
;*      ( ,      .)
;*          .
;*         .    .
;*          (, ).
;* 
;*        (),
;*    ( , , ).
;
;
;   :
; HELP_CT
; MES_CT
; M_ERROR_CT
; RESTORE_ON_EXIT_CT
; GET_SUF_INTEFG_PREF
; DO_AUTO_CT
;
;* --------------- 
;*  Acad CT 
;* --------------- 
;
(defun C:CT ( / lang mlst cmde_ old-error glob_pref glob_suf glob_en glob_en1
                si i j k what en1 incr enname val1 ss sil so sn snfl)
  ;*    (Language support)
  (setq lang 2);[1  2] 2-  -  (  )
               ;          1- English language
  
  ;.   ,     : ACAD.LSP, *.MNL, ...
  ;(Set variable for English support in ACAD.LSP, *.MNL, ...)
  (if (and language$- (or (= language$- 1)(= language$- 2)))
    (setq lang language$-)
  )
  ;   
  (if (not ct_incr-) (setq ct_incr- 1))       ;      ()
  (if (not ct_mode-) (setq ct_mode- "CHANGE")); ["CHANGE"  "AUTONUM"]     
  ;*    2 
  ;*      2-  3-  ()!
  (setq mlst '(
    (0 "Changed" "()")
    (1 "Changing values of selected texts (TEXT & MTEXT)" "    (TEXT & MTEXT)")
    (2 "Objects selected" " ")
    (3 "Press SPACE bar to erase selected text." "     .")
    (4 "In MTEXT will change only the last symbols." " MTEXT     !")
    (5 "Enter NEW value" "  ")
    (6 "Text erased" " ")
    (7 "Object(s) is not selected." "()  .")
    (8 "Can't change (erased) object on locked layer." "  ()    .")
    (9 "Erased" "()")
    (10 "Selected" "()")
    (11 "Current value" " ")
    (12 "Select text to change" "   ")
    (13 "Need TEXT or MTEXT." " TEXT  MTEXT.")
    (14 "Select text to change or" "    ")
    (15 "Current increment" "  ()")
    (16 "Select text to get 1-st value or" "     ")
    (17 "Enter increment value" "   ()")
    (18 "1-st value" "1- ")
    (19 "Prefix" "")
    (20 "Suffix" "")
    (21 "Increment" "")
    (22 "Help file not found." "   .")
    (23 "Select other texts to change values" "     ")
    (24 "Object selected" " ")
  ));end of list ** mlst ** ( )
  ;
  ; -----------------------------------
  ;      
  ; -----------------------------------
  (defun HELP_CT (index / )
    (if (findfile "KAI-2001-FW.HLP")
      (help "KAI-2001-FW.HLP" index)
      (princ (strcat "\n KAI-2001-FW.HLP"  "  " (CT_MES 19)));19="Help file not found."
    )
  ) ;end ****** HELP_CT **************
  ;
  ; ----------------------------------------------
  ;       2 
  ; ----------------------------------------------
  (defun MES_CT (num / mes2)
    ;num  =  (int)   mlst
    (if (and mlst (setq mes2 (nth num mlst))); = '(num "str_eng" str2_rus")
      (setq mes2 (nth lang mes2));    
    )  
    (if (not mes2);      
      (progn
        (alert (strcat (itoa num) "\n" "Message not found."))
        (setq mes2 "_?_")
      )
    )
    mes2
  );end of **** MES_CT *****
  ;
  ; ------------------------
  ;   
  ; ------------------------
  (defun M_ERROR_CT (errnumber)
    ;  Esc
    (if (not (member errnumber '("Function cancelled" "console break" "quit / exit abort")))
      (princ (strcat "\nERROR in program CT: " errnumber))
    )
    (princ " Cancel.")
    (RESTORE_ON_EXIT_CT);     
    (prin1)
  ); end ** M_ERROR_CT **
  ;
  ; -------------------------------------------
  ;     
  ; -------------------------------------------
  (defun RESTORE_ON_EXIT_CT ()
    (if old-error (setq *error* old-error))   ; Restore old *error* handler
    ;   
    (if si (redraw si 4))
    (if glob_en (redraw glob_en 4))
    (if (and glob_en1 (= (type glob_en1) 'ENAME))
       (redraw glob_en1 4)
    )
    ;    
    (if (or (> j 0) (and k (> k 0)))
      (princ (strcat "\n* "
                     (if (and ss (> (sslength ss) 0))
                       (strcat (itoa (sslength ss)) ". " (MES_CT 10) ".  ");10="Selected"
                       (if en1
                         (strcat (itoa 1) ". " (MES_CT 10) ".  ");10="Selected"
                         ""
                       )
                     )
                     (if (and j (> j 0))
                       (strcat (itoa j) ". " (MES_CT 0) ".  ");0="Changed"
                       ""
                     )
                     (if (and k (> k 0))
                       (strcat (itoa k) ". " (MES_CT 9) ".");9="Erased"
                       ""
                     )
              ))
    )
    (command "._UNDO" "_END") ;   
    (if cmde_ (setvar "CMDECHO" cmde_)) ; Restore cmdecho value
    (prin1)
  );end of ************** RESTORE_ON_EXIT **********
  ;
  ; ------------------------------------------------------------------------------------
  ;             
  ; ------------------------------------------------------------------------------------
  (defun GET_SUF_INTEFG_PREF (str / i j pref suf dig val1 ch strdig chd)
    ; str =  
    (setq pref "")
    (setq suf "")
    (setq dig "")
    (if (= str "")
      (setq val1 0)
      (progn
        (setq i 1)
        ;       ,       
        (while (/= (setq ch (substr str i 1)) "")
          (if (and (wcmatch ch "[-0123456789]")
                   (not (= (strcase (substr str i 3)) "\\U+")))
            (progn
              (if (or (wcmatch ch "[0123456789]")
                      (and (= ch "-") (wcmatch (substr str (1+ i) 1) "[0123456789]")))
                (progn
                  (setq strdig (substr str i (strlen str)))
                  (setq j 1)
                  (while (/= (setq chd (substr strdig j 1)) "")
                    (if (wcmatch chd "[-0123456789]")
                      (setq dig (strcat dig chd))
                      (progn
                        (setq suf (substr strdig j (strlen strdig)))
                        (setq j (strlen strdig))
                      )
                    )
                    (setq j (1+ j))
                  );while j
                  (setq i (strlen str))
                  (setq val1 (atoi dig))
                )
                (setq pref (strcat pref ch))
              )
            )
            (if (= (strcase (substr str i 3)) "\\U+")
              (progn
                (setq pref (strcat pref (substr str i 7)))
                (setq i (+ i 6))
              )
              (setq pref (strcat pref ch))
            )
          )
          (setq i (1+ i))
        );while i
      )
    )
    (if (= dig "")
      (setq val1 0)
    )
    (setq glob_pref pref);   ( )
    (setq glob_suf suf)  ;   ( )
    (setq val1 val1)     ;   ()
  );end of ******* GET_SUF_INTEFG_PREF ******
  ;
  ;
  ; ------------------------------------------------------------------------------------
  ;             
  ; ------------------------------------------------------------------------------------
  (defun DO_AUTO_CT (val / en ename sil valstr)
    (setq val (+ val ct_incr-))
    ;    ,  
    (while (setq en (entsel (strcat "\n" (MES_CT 11) " = " (itoa val);11="Current value"
                                    ".  " (MES_CT 12) ": ")));12="Select text to change"
      (setq en (car en))
      (redraw en 3);   
      (setq glob_en en)
      (setq enname (cdr (assoc 0 (entget en))))
      ;    
      (if (or (= enname "MTEXT")(= enname "TEXT"))
        (progn
          (setq sil (entget en))
          (if (and (= enname "MTEXT") (assoc 3 sil))
            (alert (strcat " " (MES_CT 4) " "));4="In MTEXT will change only the last symbols."
          )
          ;   
          (setq valstr (strcat glob_pref (itoa val) glob_suf))
          ;    
          (setq sil (subst (cons '1  valstr) (assoc 1 sil) sil))
          ;  
          (if (entmod sil)
            (progn
              (setq val (+ val ct_incr-))
              (princ " OK.")
              (setq j (1+ j))
            )
            (alert (MES_CT 8));8="Can't change (erased) object on locked layer."
          )
        )
        (alert (strcat "Object " enname ".\n\n" (MES_CT 13)));13="Need TEXT or MTEXT."
      )
      (if en (redraw en 4));  
    );while
  );end of **** DO_AUTO *************
  ;
  ;
  ; *********************************
  ;    **************
  ; *********************************
  ;
  ;  
  (setq cmde_ (getvar "CMDECHO")    ; save current setting of cmdecho
        old-error  *error*         ; save current error function
        *error* M_ERROR_CT         ; new error function
  )
  (setvar "CMDECHO" 0)       ;   
  (command "._UNDO" "_BEGIN") ;      U
  ;       F1
  (if (findfile "KAI-2001-FW.HLP")
    (setfunhelp (strcat "C:" "CT") "KAI-2001-FW.HLP" "CT")
    (princ (strcat "\n KAI-2001-FW.HLP"  "  " (MES_CT 19)));19="Help file not found."
  )
  (princ (strcat "\n(C)KAI (FA). C:CT.  " (MES_CT 1)));1="    (TEXT & MTEXT)"
  (setq glob_pref "");  (  )
  (setq glob_suf "") ;  
  (setq k 1)
  (setq j 0)
  (while k
    (if (= ct_mode- "CHANGE")
      (setq what (strcat "\n[" ct_mode- "].  " (MES_CT 14);14="Select text to change or"
                         " [Autonumbering/Help]: "))
      (progn
        (princ (strcat "\n" (MES_CT 15) "=" (itoa ct_incr-)));15="Current increment"
        (setq what (strcat "\n[" ct_mode- "].  " (MES_CT 16);16="Select text to get 1-st value or"
                           " [Increment/Change/Help]: "))
      )
    )
    ;     
    (initget "Change Autonumbering Increment Help")
    (setq en1 (entsel what))
    (cond ((= en1 "Autonumbering");    
            (progn
              (setq ct_mode- "AUTONUM")
            ));auto
          ;      
          ((= en1 "Change")
            (progn
              (setq ct_mode- "CHANGE")
            ));Help
          ((= en1 "Help")
            (progn
              (HELP_CT "CT")
            ));Help
          ;   ( )
          ((= en1 "Increment")
            (progn
              (setq incr (getint (strcat (MES_CT 17);17="Enter increment value"
                                         "< " (itoa ct_incr-) " > :"))); !
              (if incr
                (setq ct_incr- incr)
              )
            ))
          ;  
          ((= (type (car en1)) 'ENAME)
            (progn
              (setq en1 (car en1))
              (redraw en1 3);  
              (setq enname (cdr (assoc 0 (entget en1))))
              (if (or (= enname "MTEXT")(= enname "TEXT"))
                (progn
                  ;   
                  (if (= ct_mode- "AUTONUM")
                    (progn
                      (setq glob_en1 en1)
                      ;   
                      (setq val1 (cdr (assoc 1 (entget en1))))
                      ;   (      )
                      (setq val1 (GET_SUF_INTEFG_PREF val1))
                      ;   ,   
                      (princ (strcat "\n" (MES_CT 18) ": " (itoa val1);18="1-st value"
                                                     (if (/= glob_pref "")
                                                       (strcat ".   " (MES_CT 19) "=[" glob_pref "]");19="Prefix"
                                                       ""
                                                     )
                                                     (if (/= glob_suf "")
                                                       (strcat ". " (MES_CT 20) "=[" glob_suf "]");20="Suffix"
                                                       ""
                                                     )
                                                     "  " (MES_CT 21) "=" (itoa ct_incr-);21="Increment"
                                     ))
                      ;      
                      (DO_AUTO_CT val1)
                      (setq en1 nil)
                    )
                  )
                  (setq k nil)
                )
                (progn
                  (alert (strcat (MES_CT 24) ":  " enname ;24="Object selected"
                                 ".\n\n" (MES_CT 13)));13="Need TEXT or MTEXT."
                  (redraw en1 4)
                )
              )
            ));
          (T ;      (     )
            (progn
              (setq k nil)
              (setq en1 nil)
            ));
    );cond
  );while
  ;    
  (if en1
    (progn
      (princ (strcat "\n" (MES_CT 23) ": "));23="Select other texts to change values"
      ;     (  -     )
      (setq ss (ssget  '((-4 . "<OR")
                          (0 . "TEXT")
                          (0 . "MTEXT")
                      (-4 . "OR>")))
      );setq
    )
  )
  ;            
  (if en1 
    (progn
      (if (and ss (> (sslength ss) 0))
        (princ (strcat "\n* " (MES_CT 2) ": " (itoa (1+ (sslength ss))) ". "));2="Objects selected"
        (princ (strcat "\n* " (MES_CT 2) ": " (itoa 1) ". "));2="Objects selected"
      )
      (setq i 0 k 0)
      (prompt (strcat "  [ " (MES_CT 3) "]"));3="Press SPACE bar to erase selected text."
      ; 1-      
      (setq si en1)
    )
    (setq si nil)
  )
  ;     
  (while si
    (redraw si 3);   
    (setq sil (entget si))
    (if (assoc 3 sil)
      (alert (strcat " " (MES_CT 4) " "));4="In MTEXT will change only the last symbols."
    )
    (setq so (cdr (assoc 1 sil)))
    (setq sn (getstring T (strcat "\n" (MES_CT 5) " <" so ">: ")));5="Enter NEW value"
    (setq snfl nil)
    ;  -  
    (if (/= sn "")
      (progn
        (if (= sn " ")
          (progn
            (setq sn "" )
            (setq snfl 1)
          )
        )
        ;        
        (setq sil (subst (cons '1  sn) (assoc 1 sil) sil))
        ;  
        (if (entmod sil)
          (progn
            (if snfl
              (progn
                (princ (strcat " *" (MES_CT 6) "*"));6="Text erased"
                (setq k (1+ k))
              )
              (progn
                (princ " OK.")
                (setq j (1+ j))
              )
            )
          )
          (alert (MES_CT 8));8="Can't change (erased) object on locked layer."
        )
      )
    )
    (if si (redraw si 4));    
    (if ss
      (setq  si (ssname ss i)
             i (1+ i))
      (setq si nil);    
    )
    (if (and ss (equal si en1))
      (setq  si (ssname ss i)
             i (1+ i))
    )
      
  );while si
  (if (and (not en1) (not ss))
    (princ (strcat "\n *" (MES_CT 7) " "));7="Object(s) is not selected."
  )
  
  (RESTORE_ON_EXIT_CT)

  (princ " *End C:CT*")
  (prin1)
) ;end of ********* C:CT **********