;* OPEN SOURCE.     KAI-2001 (http://geol-dh.narod.ru/)
;* 
;**************** C:EE ****** Extend_Erase **************
;* 
;*    LINE,
;*         ( EXTEND),
;*      .
;* 
;* Acad 15,16 ( 13-14  )
;* ()  .., 1994,1998,2001,2003
;* .. . (413-22)5-05-10.
;* : http://geol-dh.narod.ru/   Email: ai_kosov@mail.ru
;* 
;*      ( ,      .)
;*          .
;*         .    .
;*          (, ).
;* 
;*        (),
;*    ( , , ).
;
;
;   :
; MES_EE
; M_ERROR_EE
; RESTORE_ON_EXIT_EE
;
;* --------------- 
;*  Acad EE 
;* --------------- 
;
(defun C:EE ( / lang mlst old-error str ps pe en et flag eti )
  ;*    (Language support)
  (setq lang 2);[1  2] 2-  -  (  )
               ;          1- English language
  
  ;.   ,     : ACAD.LSP, *.MNL, ...
  ;(Set variable for English support in ACAD.LSP, *.MNL, ...)
  (if (and language$- (or (= language$- 1)(= language$- 2)))
    (setq lang language$-)
  )
  ;*    2 
  ;*      2-  3-  ()!
  (setq mlst '(
    (0 "Can't erase temprary line on locked layer." "      .")
    (1 "EXTEND selected objects to temporary line." "     .")
    (2 "Current projection mode" "  ")
    (3 "TRUE 3D (no projection)." "3-  ( ).")
    (4 "To UCS plane." "  .")
    (5 "To VIEW plane." "  .")
    (6 "Extends to an imaginary extension." "   .")
    (7 "Specify START point of temporary LINE" "    ")
    (8 "END point of line" "  ")
    (9 "SELECT object to EXTEND" "   ")
    (10 "No data." " .")
    (11 "Help file not found." "   .")
  ));end of list ** mlst ** ( )
  ;
  ; ----------------------------------------------
  ;       2 
  ; ----------------------------------------------
  (defun MES_EE (num / mes2)
    ;num  =  (int)   mlst
    (if (and mlst (setq mes2 (nth num mlst))); = '(num "str_eng" str2_rus")
      (setq mes2 (nth lang mes2));    
    )  
    (if (not mes2);      
      (progn
        (alert (strcat (itoa num) "\n" "Message not found."))
        (setq mes2 "_?_")
      )
    )
    mes2
  );end of **** MES_EE *****
  ;
  ; ------------------------
  ;   
  ; ------------------------
  (defun M_ERROR_EE (errnumber)
    ;  Esc
    (if (not (member errnumber '("Function cancelled" "console break" "quit / exit abort")))
      (princ (strcat "\nERROR in program EE: " errnumber))
    )
    (RESTORE_ON_EXIT_EE);     
  );end of ** M_ERROR_EE **
  ;
  ; -------------------------------------------
  ;     
  ; -------------------------------------------
  (defun RESTORE_ON_EXIT_EE ()
    (if old-error (setq *error* old-error)) ; Restore old *error* handler
    (if en ;    
      (if (not (entdel en));  (   -  )
        (alert (MES_EE 0));0="Can't erase temprary line on locked layer."
        ;     
      )
    )
    (command "._UNDO" "_END")         ;   
    (if cmde (setvar "CMDECHO" cmde)); Restore cmdecho value
    (prin1)
  ) ;end of ******* RESTORE_ON_EXIT_EE ********
  ;
  ; *********************************
  ;    **************
  ; *********************************
  ;
  ;  
  (setq cmde (getvar "CMDECHO")    ; save current setting of cmdecho
        old-error  *error*         ; save current error function
        *error* M_ERROR_EE         ; new error function
  )
  (setvar "CMDECHO" 0)      ;   
  (command "._UNDO" "_BEGIN");      U
  
  ;       F1
  (if (findfile "KAI-2001-FW.HLP")
    (setfunhelp (strcat "C:" "EE") "KAI-2001-FW.HLP" "EE")
    (princ (strcat "\n KAI-2001-FW.HLP"  "  " (MES_EE 11)));11="Help file not found."
  )
  ;   
  (princ (strcat "\n(C)KAI (FA). C:EE (ExtendErase) " (MES_EE 1)));1="EXTEND selected objects to temporary line."
  (setq str (strcat (MES_EE 2) ": "));2="Current projection mode"
  (cond ((= (getvar "PROJMODE") 0)
           (setq str (strcat str (MES_EE 3)));3="TRUE 3D (no projection)."
          )
        ((= (getvar "PROJMODE") 1)
           (setq str (strcat str (MES_EE 4)));4="To UCS plane."
          )
        ((= (getvar "PROJMODE") 2)
           (setq str (strcat str (MES_EE 5)));5="To VIEW plane."
          )
  )
  (if (= (getvar "EDGEMODE") 1)
    (setq str (strcat str "  " (MES_EE 6)));6="Extends to an imaginary extension."
  )
  (princ (strcat "\n" str))
  ;       
  (setq ps (getpoint (strcat "\n" (MES_EE 7) ": ")));7="Specify START point of temporary LINE"
  (if ps
    (progn
      (setq pe (getpoint ps (strcat "\n  " (MES_EE 8) ": ")));8="END point of line"
      (if pe
        (progn
          (command "._LINE" ps pe "")
          (setq en (entlast))
          (redraw en 3);  
          (setq et (list en ps));        
        )
      ) ;if pe
    )
  ) ;if ps
  
  ;          
  (setq flag nil);        
  (if (and ps et)
    (while (setq eti (entsel (strcat "\n" (MES_EE 9) ": ")));9="SELECT object to EXTEND"
      (command "._EXTEND" et "" eti "")
      (redraw en 3);  
      (setq flag "YES")
    ) ;while
  ) 
  ;     
  (princ "* End C:EE *")
  ;   ,     
  (if (or (not ps) (not pe) (not flag))
    (princ (strcat " " (MES_EE 10)));10="No data."
  )
  (RESTORE_ON_EXIT_EE);  ,  
  (prin1);  
);end of ************** C:EE ***************