;* OPEN SOURCE.     KAI-2001 (http://geol-dh.narod.ru/)
;* 
;**************** C:FN ****** File_Name **************
;* 
;*       (  )
;*    , , , ..  Loginname
;*    .     .
;*        ( ).
;*    STAMP    .
;*    ITA08     ( -  Standard)
;*    (.SET )       
;*          (, )
;* 
;* Acad 10,12,13,14,15,16
;* ()  .., 1994,1998,2001,2003
;* .. . (413-22)5-05-10. 
;* : http://geol-dh.narod.ru/   Email: ai_kosov@mail.ru
;* 
;*      ( ,      .)
;*          .
;*         .    .
;*          (, ).
;* 
;*        (),
;*    ( , , ).
;
;  . FN.SET
;
;   :
; DELAY_FN
; ALERT_STYLE
; ALERT_LAYER
; MES_FN
; M_ERROR
; RESTORE_ON_EXIT
; FN
;
;* --------------- 
;*  Acad FN 
;* --------------- 
;
;*    (Language support)
(setq lang 2);[1  2] 2-  -  (  )
             ;          1- English language

;.   ,     : ACAD.LSP, *.MNL, ...
;(Set variable for English support in ACAD.LSP, *.MNL, ...)
(if (and kai_language- (or (= kai_language- 1)(= kai_language- 2)))
  (setq lang kai_language-)
)

;      
(defun DELAY_FN (del / delr delbeg delcur) ;    ( )
  ;del [real]    
  (setq delr (/ del 86400.0))    ;    24 
  (setq delbeg (getvar "DATE")) ; date and time (real)
  (setq delcur delbeg)          ;   
  (while (< delcur (+ delbeg delr))
    (setq delcur (getvar "DATE"))    ;current date and time (real)
  )
);end of ******* DELAY_FN ********
;
;
; --------------------------------------------------------------------
;    ,      
; --------------------------------------------------------------------
(defun ALERT_STYLE (tst / lst flag)
  (if (setq lst (tblsearch "STYLE" tst))
    (progn
      (setq flag (cdr (assoc 40 lst)))
      (if (not (or (= flag 0.0) (not flag)))
        (progn
          (alert (strcat (strcase tst) ".  " (MES_FN 7);7="Text STYLE must be set with 0.0 height."
                         "\n" (MES_FN 8)  ;8="Set this style and style 'STANDARD' with 0.0 height."
                         "\n" (MES_FN 6)));6="Cancel program."
          (EXIT)
        )
      )
    )
    (princ (strcat "" (strcase tst) ".  " (MES_FN 3 fun$meslist- fun$lang-)));3="STYLE of TEXT NOT FOUND."
  )
);end of *********** ALERT_STYLE *******
;
; -------------------------------------------------------------- 
;   ,   ,  ,  XREF 
; ---------------------------------------------------------------
(defun ALERT_LAYER (lay)
  ;  ,  ,  XREF
  (if (and (tblsearch "LAYER" lay) (or (not (zerop (logand (cdr (assoc 70 (tblsearch "LAYER" lay))) (+ 1 2 4 16 32))))
                                   (minusp (cdr (assoc 62 (tblsearch "LAYER" (getvar "CLAYER")))))
          ))
    (progn
      (alert (strcat (strcase lay)
                     ".\n" (MES_FN 5);5="Open and/or Thaw LAYER."
                     ));
      (princ (strcat "\n" (MES_FN 6)));6="Cancel program."
      (EXIT)
    )
    T
  )
);end of ***** ALERT_LAYER ******
;
; ----------------------------------------------
;       2 
; ----------------------------------------------
(defun MES_FN (num / mes2)
  ;num  =  (int)   mlst
  (if (and kai_meslist- (setq mes2 (nth num kai_meslist-))); = '(num "str_eng" str2_rus")
    (setq mes2 (nth lang mes2));    
  )  
  (if (not mes2);      
    (progn
      (alert (strcat (itoa num) "\n" "Message not found."))
      (setq mes2 "_?_")
    )
  )
  mes2
);end of **** MES_FN *****
;
; ------------------------
;    
; ------------------------
(defun M_ERROR (errnumber)
  ;  Esc
  (if (not (member errnumber '("Function cancelled" "console break" "quit / exit abort")))
    (princ (strcat "\nERROR in program FN: " errnumber))
  )
  (RESTORE_ON_EXIT);     
);end of ** M_ERROR **
;
; -------------------------------------------
;      
; -------------------------------------------
(defun RESTORE_ON_EXIT ()
  (if old-error (setq *error* old-error)) ; Restore old *error* handler
  (if old-error (setq *error* old-error))   ; Restore old *error* handler
  (if htxt_     (setvar "TEXTSIZE" htxt_))
  (if cst_      (setvar "TEXTSTYLE" cst_))
  (if osm-old_  (setvar "OSMODE" osm-old_))
  (if ab_       (setvar "ANGBASE" ab_))
  (if ad_       (setvar "ANGDIR" ad_))
  ;   
  (setq  DELAY_FN nil RESTORE_ON_EXIT nil M_ERROR nil ALERT_LAYER nil ALERT_STYLE nil MES_FN nil)
  (command "._UNDO" "_END")         ;   
  (if cmde (setvar "CMDECHO" cmde)); Restore cmdecho value
  (prin1)
) ;end of ******* RESTORE_ON_EXIT ********
;
; *********************************
;    **************
; *********************************
;
(defun FN ( / kai_meslist- ht mode modet moded lgname1 lgname2 lgname3
              logname_if_geo naxfn lay st del ang
              cmde_ htxt_ cst_ osm-old_ ab_ ad_ old-error rel dwg pre year logname cp sl ver_a c
              what1 what2 x y xtv xtf wp1 wp2 cp2 ss ss10 i e laylst laycol)

  ;  
  (setq cmde_ (getvar "CMDECHO")   ; save current setting of cmdecho
        htxt_ (getvar "TEXTSIZE")  ;  
        cst_  (getvar "TEXTSTYLE") ;  
        osm-old_ (getvar "OSMODE") ;  
        ab_   (getvar "ANGBASE")   ; 
        ad_   (getvar "ANGDIR")    ; 
        old-error  *error*         ; save current error function
        *error* M_ERROR            ; new error function
  )
  (setvar "CMDECHO" 0)

  (if (findfile "FN.SET");   setup
    (progn
      (princ (strcat "\nLoading parameters from FN.SET..."))
      (load "FN.SET")
      (princ (strcat "OK\n"))
    )
    (progn
      (alert "FN.SET.  Parameters file not found.\n\nCancel program.")
      (EXIT)
    )
  )
  ;     
  (FN_SETUP)
  (setvar "ANGBASE" 0) ;.  ..  !
  (setvar "ANGDIR" 0)
  ;       F1
  (if (findfile "KAI-2001-FW.HLP")
    (setfunhelp (strcat "C:" "FN") "KAI-2001-FW.HLP" "FN")
    (princ (strcat "\n KAI-2001-FW.HLP"  "  " (MES_FN 9)));9="Help file not found."
  )
  ; ,    ()  
  (ALERT_LAYER (getvar "CLAYER"));  
  (if (tblsearch "LAYER" lay);  STAMP ( , . SET )
    (ALERT_LAYER lay)
  )
  ;        (. SET )
  (if (tblsearch "STYLE" st)
    (setvar "TEXTSTYLE" st)
    (progn 
      (setvar "TEXTSTYLE" "STANDARD")
      (setq st "STANDARD")
    )
  )
  ;   
  (ALERT_STYLE st)
  ;  Acad
  (setq rel (getvar "ACADVER"))
  ;      U
  (if (= (substr rel 1 2) "10")
    (command "UNDO" "GROUP")
    (command "._UNDO" "_BEGIN")
  )
  (setq rel (substr rel 1 6))
  ;  
  (setq dwg (getvar "DWGNAME"))
  ;   
  (setq pre (getvar "DWGPREFIX"))
  ;  
  (setq year (substr (rtos (getvar "CDATE") 2 0) 1 4))
  (setq year (strcat year "." (substr (rtos (getvar "CDATE") 2 0) 5 2)))
  (setq year (strcat year "." (substr (rtos (getvar "CDATE") 2 0) 7 2)))
  (setq logname (getvar "LOGINNAME"))
  ;  Loginname  -  (.  SET).
  ;    ,       ,    .
  (if (or (= (strcase logname) (strcase lgname1)) (= (strcase logname) (strcase lgname2)) (= (strcase logname) (strcase lgname3)))
    (progn
      (setq logname logname_if_geo) ;IF GEO!!!
    )
  )
  ;     ( )   
  (cond
    ((= (substr rel 1 2) "10")
      (progn
        (setq dwg (strcat pre dwg ".dwg"))
        (setq cp "dos")
      ))
    ((= (substr rel 1 2) "12")
      (progn
        (setq dwg (strcat pre dwg ".dwg"))
        (setq cp (getvar "SYSCODEPAGE"))
      ))
    ((= (substr rel 1 2) "13")
      (progn
        (if (wcmatch dwg "@:\\*")
          (setq dwg (strcat dwg ".dwg"))
          (setq dwg (strcat pre dwg ".dwg"))
        )
        (setq cp (getvar "SYSCODEPAGE"))
      ))
    ((= (substr rel 1 2) "14")
      (progn
        (setq dwg (strcat pre dwg))
        (setq cp (getvar "SYSCODEPAGE"))
      ))
    ((= (substr rel 1 2) "15")
      (progn
        (setq dwg (strcat pre dwg))
        (setq cp (getvar "SYSCODEPAGE"))
      ))
    ((= (substr rel 1 2) "16")
      (progn
        (setq dwg (strcat pre dwg))
        (setq cp (getvar "SYSCODEPAGE"))
      ))
    (T
      (progn
        (setq dwg dwg)
        (setq cp "??")
        (princ (strcat "\n" "Acad Rel??"));   
      ))
  );cond
  (setq dwg (strcase dwg));     (     )
  ;       (     )
  (if (> (setq sl (strlen dwg)) maxfn);.   (80)
    (setq dwg (strcat (substr dwg 1 (1- (/ maxfn 2))) "..." (substr dwg (- sl (1- (/ maxfn 2))) (/ maxfn 2))))
  )
  ;  : , ,  , 
  (setq ver_a (strcat year ". Acad Rel." rel " [" cp "] " logname))
  ;   
  (princ (strcat "\n(C)KAI (FA). C:FN. " (MES_FN 0)));0="  ."
  ;  ? 1  2 (.  SET)
  (if (= modet 2)
    (princ (strcat "\n" dwg "  **  " ver_a))
    (princ (strcat "\n" dwg ))
  )
  (setq what1 (strcat "\n" (MES_FN 1)));1="      [eXit] <0,0>: "
  (setq what2 (strcat "\n" (MES_FN 2)));2="     [eXit] <0,0>: "
  (initget "eXit")
  ;   
  (if (= mode 1)
    (setq c (getpoint what1));
    (setq c (getpoint what2));
  )
  (if (not (= c "eXit"))
    (progn
      (if (= (type c) 'LIST)
        (setq c c)
        (setq c '(0 0));        (0 0)
      )
      (setq x (car c) y (cadr c))

      (if (not (= (substr rel 1 2) "10"));  12??
        (progn
          (if (= moded 1);      
            (progn
              (setq wp1 (append (list (- x 30.0)) (list (- y 2.0))));  zoom
              (setq wp2 (append (list (+ x 100.0)) (list (+ y 95.0))));  zoom
              (command "._ZOOM" "_W" wp1 wp2)
              (DELAY_FN del);    ()
            )
          )
        )
      )
      (if (= mode 1)
        (setq cp2 (append (list (+ x 8.0)) (list (+ y 90.0))));  ssget
        (setq cp2 (append (list (- x 8.0)) (list (+ y 90.0))));  ssget
      )
      (setq ss nil)
      ;       
      (if (= (substr rel 1 2) "10")
        (progn
          (setq ss (ssget "C" c cp2 ))
          (if ss
            (progn
              (setq ss10 (ssadd))
              (setq i 0)
              (while (setq e (ssname ss i)) ;  
                (if (= (cdr (assoc 0 (entget e))) "TEXT")
                  (setq ss10 (ssadd e ss10))
                )
                (setq i (1+ i))
              )
              (if (> (sslength ss10) 0)
                (setq ss ss10)
                (setq ss nil)
              )
            )
          )
        )
        (setq ss (ssget "C" c cp2 '((0 . "TEXT")))) ;rel>10
      )
      ;    ( )
      (if ss
        (progn
          (command "._ERASE" ss "")
          (alert (strcat "\n" (MES_FN 3) " = " (itoa (sslength ss))));3="!    'TEXT'"
        )
      )
      ;   
      (if (= mode 1)
        (progn
          (setq xtv (append (list (+ x 3.5)) (list (+ y 6.0))));  ver_a
          (setq xtf (append (list (+ x 6.5)) (list (+ y 6.0))));  dwg
        )
        (progn
          (setq xtv (append (list (- x 3.0)) (list (+ y 0.0))));  ver_a
          (setq xtf (append (list (+ x 0.0)) (list (+ y 0.0))));  dwg
        )
      )
      (setq ss (ssadd))
      (setvar "OSMODE" 0)
      ;  
      (if (= modet 2)
        (progn
          (command "._TEXT" xtv ht ang ver_a)
          (setq ss (ssadd (entlast) ss))
        )
      )
      ;  
      (command "._TEXT" xtf ht ang dwg)
      (setq ss (ssadd (entlast) ss))
      ;      (STAMP, . SET)
      (if (setq laylst (tblsearch "LAYER" lay))
        (progn
          (setq laycol (cdr (assoc 62 laylst)));color
          (if (or (minusp laycol) (not(zerop (logand (cdr (assoc 70 laylst)) (+ 1 2)))))
            (alert (strcat  lay  ". " (MES_FN 4)));4="     ."
            (command "._CHANGE" ss "" "_P" "_LAYER" lay "")
          )
        )
      )
      (if (not (= (substr rel 1 2) "10"))
        (if (= moded 1)
          (progn
            (DELAY_FN del);    ()
            (command "._ZOOM" "_P")
          )
        )
      )
    );progn - 
  );not quit
  (RESTORE_ON_EXIT);  ,  
  (princ "\n* End FN *")
  (prin1)
) ;end of ************** FN ***************

;* -----------------------------------------------------------------------
;*  Acad FN.  ,     FN. 
;* -----------------------------------------------------------------------
;
(defun C:FN ();      ,       .
  (princ "\nLoading....")
  (if (or (findfile "FN.fas") (findfile "FN.lsp"))
    (progn
      (load "FN") (princ "OK") (FN) (setq FN nil)
    )
    (alert " Program FN not found. ");    .
  )
  (prin1)
) ;end of **************C:GEOL_DH***************