;* OPEN SOURCE.     KAI-2001 (http://geol-dh.narod.ru/)
;* 
;**************** C:J ****** Properties **************
;* 
;*     :
;* , (), ()     
;* ,    ,
;*  ,
;*    
;* 
;* Acad 15,16 ( 13-14  )
;* ()  .., 1996,2001,2003
;* .. . (413-22)5-05-10.
;* : http://geol-dh.narod.ru/   Email: ai_kosov@mail.ru
;* 
;*      ( ,      .)
;*          .
;*         .    .
;*          (, ).
;* 
;*        (),
;*    ( , , ).
;
;   :
; MES_J
; M_ERROR_J
; RESTORE_ON_EXIT_J
;
;* ---------------
;*  Acad J 
;* ---------------
;
(defun C:J (/ old-error cmde el ec la lt text elp ht st col bn fn collayer ltlayer)
  ;*    (Language support)
  (setq lang 2);[1  2] 2-  -  (  )
               ;          1- English language
  
  ;.   ,     : ACAD.LSP, *.MNL, ...
  ;(Set variable for English support in ACAD.LSP, *.MNL, ...)
  (if (and language$- (or (= language$- 1)(= language$- 2)))
    (setq lang language$-)
  )
  ;*    2 
  ;*      2-  3-  ()!
  (setq mlst '(
    (0 "Show object properties: LAYER, COLOR, LTYPE, ets." "  : , ,   .")
    (1 "Select object" " ")
    (2 "Layer" "")
    (3 "Color" "")
    (4 "LType" "")
    (5 "LWeight" "")
    (6 "TStyle" "")
    (7 "BName" "")
    (8 "Next" "")
    (9 "Abbreviations: BB - by block,  BL - by layer." ": BB -  , BL -  .")
    (10 "Help file not found." "   .")
  ));end of list ** mlst ** ( )
  ;
  ; ----------------------------------------------
  ;       2 
  ; ----------------------------------------------
  (defun MES_J (num / mes2)
    ;num  =  (int)   mlst
    (if (and mlst (setq mes2 (nth num mlst))); = '(num "str_eng" str2_rus")
      (setq mes2 (nth lang mes2));    
    )  
    (if (not mes2);      
      (progn
        (alert (strcat (itoa num) "\n" "Message not found."))
        (setq mes2 "_?_")
      )
    )
    mes2
  );end of **** MES_J *****
  ;
  ;
  ; ------------------------
  ;   
  ; ------------------------
  (defun M_ERROR_J (errnumber)
    ;  Esc
    (if (not (member errnumber '("Function cancelled" "console break" "quit / exit abort")))
      (princ (strcat "\nERROR in program J: " errnumber))
    )
    (RESTORE_ON_EXIT_J);     
  );end of ** M_ERROR_J **
  ;
  ; -------------------------------------------
  ;     
  ; -------------------------------------------
  (defun RESTORE_ON_EXIT_J ()
    (if old-error (setq *error* old-error)) ; Restore old *error* handler
    (if elp (redraw elp 4))
    (if cmde (setvar "CMDECHO" cmde)); Restore cmdecho value
    (prin1)
  ) ;end of ******* RESTORE_ON_EXIT_J ********
  ;
  ; *********************************
  ;    **************
  ; *********************************
  ;
  ;  
  (setq cmde (getvar "CMDECHO")    ; save current setting of cmdecho
        old-error  *error*         ; save current error function
        *error* M_ERROR_J            ; new error function
  )
  (setvar "CMDECHO" 0)
  ;
  ;       F1
  (if (findfile "KAI-2001-FW.HLP")
    (setfunhelp (strcat "C:" "J") "KAI-2001-FW.HLP" "J")
    (princ (strcat "\n KAI-2001-FW.HLP"  "  " (MES_J 10)));10="Help file not found."
  )
  (princ (strcat "\n" (MES_J 9)));9="Abbreviations: BB - by block,  BL - by layer"
  (princ (strcat "\n(C)KAI (FA). C:J. " (MES_J 0)));0="Show object properties: LAYER, COLOR, LTYPE, ets."
  (setq el (car (entsel (strcat "\n" (MES_J 1) ": "))));1="Select object"
  (while el
    (redraw el 3)
    (setq ec (entget el))         ;  
    (setq la (cdr (assoc 8 ec)))  ;
    (setq lt (cdr (assoc 6 ec)))  ; .
    (setq lwid nil)
    (if (or (= (substr (getvar "ACADVER") 1 2) "15") (= (substr (getvar "ACADVER") 1 2) "16"))
      (if (not (setq lwid (cdr (assoc 370 ec))))
        (setq lwid 9999); ByLayer
      )
    )
    (setq what (cdr (assoc 0 ec))) ;
    (setq col (cdr (assoc 62 ec))) ;
    (setq text (strcat "\n" (MES_J 2) "="));2="Layer"
    (if la
      (setq text (strcat text la "; " (MES_J 3) "="));3="Color"
      (setq text (strcat text "; " (MES_J 3) "="));3="Color"
    )
    (if col
      (if (/= col 0)
        (setq text (strcat text (itoa col) "; " (MES_J 4) "="));4="LType"
        (setq text (strcat text "BB; " (MES_J 4) "="));4="LType"
      )
      (progn
        (setq collayer nil)
        (setq collayer (itoa (cdr (assoc 62 (tblsearch "LAYER" la)))))
        (if collayer
          (setq text (strcat text "BL [" collayer "]; " (MES_J 4) "="));4="LType"
          (setq text (strcat text "BL; " (MES_J 4) "="));4="LType"
        )
      )
    )
    (if lt
      (setq text (strcat text lt ";"))
      (progn
        (setq ltlayer nil)
        (setq ltlayer (cdr (assoc 6 (tblsearch "LAYER" la))))
        (setq text (strcat text "BL [" ltlayer "];"))
      )
    )
    (if lwid
      (progn
        (if (= lwid 9999)
          (setq lwid "BL")
          (setq lwid (rtos (/ (float lwid) 100) 2 2))
        )
        (setq text (strcat text " " (MES_J 5) "=" lwid ";"));5="LWeight"
      )
    )
    (if (or (= what "TEXT") (= what "MTEXT"))
      (progn
        (setq ht (cdr (assoc 40 ec)))  ; 
        (setq st (cdr (assoc 7 ec)))  ; 
        (if st
          (setq st st)
          (setq st "STANDARD")
        )
        (setq fn (tblsearch "STYLE" st))
        (setq fn (strcase (cdr (assoc 3 fn))))
        (if ht
          (setq text (strcat text " H=" (rtos ht 2 2) ";"))
        )
        (if st
          (setq text (strcat text " " (MES_J 6) "=" st " [" fn "];"));6="TStyle"
        )
      )
    )
    (if (= what "POLYLINE")
      (if (not (zerop (logand (cdr (assoc 70 ec)) 8))) ;3Dpoly
        (setq what "3DPOLY")
        (if (not (zerop (logand (cdr (assoc 70 ec)) 16))) ;mesh
          (setq what "MESH")
        )
      )
    )
    (if (= what "INSERT")
      (progn
        (setq bn (cdr (assoc 2 ec)))  ; 
        (if bn
          (setq text (strcat text " " (MES_J 7) "=" bn ";"));7="BName"
        )
      )
    )
    (setq text (strcat text " *" what "*"))
    (princ text)
    (setq elp el)
    (setq el (car (entsel (strcat "* " (MES_J 8) ": "))));8="Next"
    (redraw elp 4)
  );while
  (if elp (redraw elp 4))
  (setq *error* old-error)   ; Restore old *error* handler
  (if cmde (setvar "CMDECHO" cmde))         ; Restore cmdecho value
  (princ "* End C:J *")
  (RESTORE_ON_EXIT_J)
  (prin1)
) ;end of **************C:J***************